﻿#property copyright "Copyright 2021, Malik Arykov"
#property link      "www.cayman-pro.ga"

#include <Cayman/Logger.mqh>

class TestClass {
    int m_id;
public:
    TestClass(int id) { 
        m_id = id;
        LOG_DEBUG(StringFormat("create object with id = %i", id));
    };
};

void OnStart() {

    string urlSeq = "http://seqlocal.net:5341/api/events/raw?clef";
    gLog = new Logger("TestLogger", urlSeq);
    
    LOG_DEBUG("debug message");
    LOG_INFO("info message");
    LOG_WARNING("warning message");
    LOG_ERROR("error message");
    LOG_FATAL("fatal message");
    
    // call function
    TestFunc();
    
    // create object
    TestClass *testObj = new TestClass(101);

    // free memery
    delete testObj;
    delete gLog;
}

void TestFunc() {
    LOG_INFO("info message from inner function");
}

/*
2022.02.16 20:17:21.048	TestLogger (USDJPY,H1)	DBG: OnStart debug message
2022.02.16 20:17:21.291	TestLogger (USDJPY,H1)	INF: OnStart info message
2022.02.16 20:17:21.299	TestLogger (USDJPY,H1)	WRN: OnStart warning message
2022.02.16 20:17:21.303	TestLogger (USDJPY,H1)	ERR: OnStart error message
2022.02.16 20:17:21.323	TestLogger (USDJPY,H1)	FTL: OnStart fatal message
2022.02.16 20:17:21.328	TestLogger (USDJPY,H1)	INF: TestFunc info message from inner function
2022.02.16 20:17:21.332	TestLogger (USDJPY,H1)	DBG: TestClass::TestClass create object with id = 101

*/
